Index: arch/sparc/sparc/locore.s
===================================================================
RCS file: /cvs/src/sys/arch/sparc/sparc/locore.s,v
retrieving revision 1.72
diff -u -r1.72 locore.s
--- arch/sparc/sparc/locore.s	29 May 2007 09:54:01 -0000	1.72
+++ arch/sparc/sparc/locore.s	25 Sep 2007 09:53:58 -0000
@@ -4383,290 +4383,52 @@
 	.comm	_C_LABEL(masterpaddr), 4
 
 /*
- * Switch statistics (for later tweaking):
- *	nswitchdiff = p1 => p2 (i.e., chose different process)
- *	nswitchexit = number of calls to switchexit()
- *	_cnt.v_swtch = total calls to swtch+swtchexit
+ * cpu_switchto(struct proc *oldproc, struct proc *newproc)
  */
-	.comm	_C_LABEL(nswitchdiff), 4
-	.comm	_C_LABEL(nswitchexit), 4
-
-/*
- * REGISTER USAGE IN cpu_switch AND switchexit:
- * This is split into two phases, more or less
- * `before we locate a new proc' and `after'.
- * Some values are the same in both phases.
- * Note that the %o0-registers are not preserved across
- * the psr change when entering a new process, since this
- * usually changes the CWP field (hence heavy usage of %g's).
- *
- *	%g1 = oldpsr (excluding ipl bits)
- *	%g2 = %hi(_C_LABEL(whichqs)); newpsr
- *	%g3 = p
- *	%g4 = lastproc
- *	%g5 = <free>; newpcb
- *	%g6 = %hi(_C_LABEL(cpcb))
- *	%g7 = %hi(_C_LABEL(curproc))
- *	%o0 = tmp 1
- *	%o1 = tmp 2
- *	%o2 = tmp 3
- *	%o3 = tmp 4; whichqs; vm
- *	%o4 = tmp 4; which; sswap
- *	%o5 = tmp 5; q; <free>
- */
-
-/*
- * switchexit is called only from cpu_exit() before the current process
- * has freed its kernel stack; we must free it.  (curproc is already NULL.)
- *
- * We lay the process to rest by changing to the `idle' kernel stack,
- * and note that the `last loaded process' is nonexistent.
- */
-ENTRY(switchexit)
-	mov	%o0, %g2		! save proc for exit2() call
-
-	/*
-	 * Change pcb to idle u. area, i.e., set %sp to top of stack
-	 * and %psr to PSR_S|PSR_ET, and set cpcb to point to _idle_u.
-	 * Once we have left the old stack, we can call kmem_free to
-	 * destroy it.  Call it any sooner and the register windows
-	 * go bye-bye.
-	 */
-	set	_C_LABEL(idle_u), %g5
-	sethi	%hi(_C_LABEL(cpcb)), %g6
-	mov	1, %g7
-	wr	%g0, PSR_S, %psr	! change to window 0, traps off
-	wr	%g0, 2, %wim		! and make window 1 the trap window
-	st	%g5, [%g6 + %lo(_C_LABEL(cpcb))]	! cpcb = &idle_u
-	st	%g7, [%g5 + PCB_WIM]	! idle_u.pcb_wim = log2(2) = 1
-	set	_C_LABEL(idle_u) + USPACE-CCFSZ, %sp	! set new %sp
-#ifdef DEBUG
-	set	_C_LABEL(idle_u), %l6
-	SET_SP_REDZONE(%l6, %l5)
-#endif
-	wr	%g0, PSR_S|PSR_ET, %psr	! and then enable traps
-	call    _C_LABEL(exit2)			! exit2(p)
-	 mov    %g2, %o0
-
-	/*
-	 * Now fall through to `the last switch'.  %g6 was set to
-	 * %hi(_C_LABEL(cpcb)), but may have been clobbered in kmem_free,
-	 * so all the registers described below will be set here.
-	 *
-	 * REGISTER USAGE AT THIS POINT:
-	 *	%g1 = oldpsr (excluding ipl bits)
-	 *	%g2 = %hi(_C_LABEL(whichqs))
-	 *	%g4 = lastproc
-	 *	%g6 = %hi(_C_LABEL(cpcb))
-	 *	%g7 = %hi(_C_LABEL(curproc))
-	 *	%o0 = tmp 1
-	 *	%o1 = tmp 2
-	 *	%o3 = whichqs
-	 */
-
-	INCR(_C_LABEL(nswitchexit))		! nswitchexit++;
-	INCR(_C_LABEL(uvmexp)+V_SWTCH)		! cnt.v_switch++;
-
-	mov	PSR_S|PSR_ET, %g1	! oldpsr = PSR_S | PSR_ET;
-	sethi	%hi(_C_LABEL(whichqs)), %g2
-	clr	%g4			! lastproc = NULL;
+ENTRY(cpu_switchto)
 	sethi	%hi(_C_LABEL(cpcb)), %g6
 	sethi	%hi(_C_LABEL(curproc)), %g7
-	/* FALLTHROUGH */
-
-/*
- * When no processes are on the runq, switch
- * idles here waiting for something to come ready.
- * The registers are set up as noted above.
- */
-	.globl	idle
-idle:
-	st	%g0, [%g7 + %lo(_C_LABEL(curproc))] ! curproc = NULL;
-	wr	%g1, 0, %psr		! (void) spl0();
-1:					! spin reading _whichqs until nonzero
-	ld	[%g2 + %lo(_C_LABEL(whichqs))], %o3
-	tst	%o3
-	bnz,a	Lsw_scan
-	 wr	%g1, IPL_CLOCK << 8, %psr	! (void) splclock();
-	b,a	1b
-
-Lsw_panic_rq:
-	sethi	%hi(1f), %o0
-	call	_C_LABEL(panic)
-	 or	%lo(1f), %o0, %o0
-Lsw_panic_wchan:
-	sethi	%hi(2f), %o0
-	call	_C_LABEL(panic)
-	 or	%lo(2f), %o0, %o0
-Lsw_panic_srun:
-	sethi	%hi(3f), %o0
-	call	_C_LABEL(panic)
-	 or	%lo(3f), %o0, %o0
-1:	.asciz	"switch rq"
-2:	.asciz	"switch wchan"
-3:	.asciz	"switch SRUN"
-	_ALIGN
-
-/*
- * cpu_switch() picks a process to run and runs it, saving the current
- * one away.  On the assumption that (since most workstations are
- * single user machines) the chances are quite good that the new
- * process will turn out to be the current process, we defer saving
- * it here until we have found someone to load.  If that someone
- * is the current process we avoid both store and load.
- *
- * cpu_switch() is always entered at splstatclock or splhigh.
- *
- * IT MIGHT BE WORTH SAVING BEFORE ENTERING idle TO AVOID HAVING TO
- * SAVE LATER WHEN SOMEONE ELSE IS READY ... MUST MEASURE!
- */
-	.globl	_C_LABEL(time)
-ENTRY(cpu_switch)
-	/*
-	 * REGISTER USAGE AT THIS POINT:
-	 *	%g1 = oldpsr (excluding ipl bits)
-	 *	%g2 = %hi(_C_LABEL(whichqs))
-	 *	%g3 = p
-	 *	%g4 = lastproc
-	 *	%g5 = tmp 0
-	 *	%g6 = %hi(_C_LABEL(cpcb))
-	 *	%g7 = %hi(_C_LABEL(curproc))
-	 *	%o0 = tmp 1
-	 *	%o1 = tmp 2
-	 *	%o2 = tmp 3
-	 *	%o3 = tmp 4, then at Lsw_scan, whichqs
-	 *	%o4 = tmp 5, then at Lsw_scan, which
-	 *	%o5 = tmp 6, then at Lsw_scan, q
-	 */
-	sethi	%hi(_C_LABEL(whichqs)), %g2	! set up addr regs
-	sethi	%hi(_C_LABEL(cpcb)), %g6
-	ld	[%g6 + %lo(_C_LABEL(cpcb))], %o0
-	std	%o6, [%o0 + PCB_SP]	! cpcb->pcb_<sp,pc> = <sp,pc>;
+	ld	[%g6 + %lo(_C_LABEL(cpcb))], %o2
+	std	%o6, [%o2 + PCB_SP]	! cpcb->pcb_<sp,pc> = <sp,pc>;
 	rd	%psr, %g1		! oldpsr = %psr;
-	sethi	%hi(_C_LABEL(curproc)), %g7
-	ld	[%g7 + %lo(_C_LABEL(curproc))], %g4	! lastproc = curproc;
-	st	%g1, [%o0 + PCB_PSR]	! cpcb->pcb_psr = oldpsr;
+	st	%g1, [%o2 + PCB_PSR]	! cpcb->pcb_psr = oldpsr;
 	andn	%g1, PSR_PIL, %g1	! oldpsr &= ~PSR_PIL;
 
 	/*
-	 * In all the fiddling we did to get this far, the thing we are
-	 * waiting for might have come ready, so let interrupts in briefly
-	 * before checking for other processes.  Note that we still have
-	 * curproc set---we have to fix this or we can get in trouble with
-	 * the run queues below.
-	 */
-	st	%g0, [%g7 + %lo(_C_LABEL(curproc))]	! curproc = NULL;
-	wr	%g1, 0, %psr			! (void) spl0();
-	nop; nop; nop				! paranoia
-	wr	%g1, IPL_CLOCK << 8 , %psr	! (void) splclock();
-
-Lsw_scan:
-	nop; nop; nop				! paranoia
-	ld	[%g2 + %lo(_C_LABEL(whichqs))], %o3
-
-	/*
-	 * Optimized inline expansion of `which = ffs(whichqs) - 1';
-	 * branches to idle if ffs(whichqs) was 0.
-	 */
-	set	ffstab, %o2
-	andcc	%o3, 0xff, %o1		! byte 0 zero?
-	bz,a	1f			! yes, try byte 1
-	 srl	%o3, 8, %o0
-	b	2f			! ffs = ffstab[byte0]; which = ffs - 1;
-	 ldsb	[%o2 + %o1], %o0
-1:	andcc	%o0, 0xff, %o1		! byte 1 zero?
-	bz,a	1f			! yes, try byte 2
-	 srl	%o0, 8, %o0
-	ldsb	[%o2 + %o1], %o0	! which = ffstab[byte1] + 7;
-	b	3f
-	 add	%o0, 7, %o4
-1:	andcc	%o0, 0xff, %o1		! byte 2 zero?
-	bz,a	1f			! yes, try byte 3
-	 srl	%o0, 8, %o0
-	ldsb	[%o2 + %o1], %o0	! which = ffstab[byte2] + 15;
-	b	3f
-	 add	%o0, 15, %o4
-1:	ldsb	[%o2 + %o0], %o0	! ffs = ffstab[byte3] + 24
-	addcc	%o0, 24, %o0		! (note that ffstab[0] == -24)
-	bz	idle			! if answer was 0, go idle
-	 EMPTY
-2:	sub	%o0, 1, %o4		! which = ffs(whichqs) - 1
-3:	/* end optimized inline expansion */
-
-	/*
-	 * We found a nonempty run queue.  Take its first process.
-	 */
-	set	_C_LABEL(qs), %o5		! q = &qs[which];
-	sll	%o4, 3, %o0
-	add	%o0, %o5, %o5
-	ld	[%o5], %g3		! p = q->ph_link;
-	cmp	%g3, %o5		! if (p == q)
-	be	Lsw_panic_rq		!	panic("switch rq");
-	 EMPTY
-	ld	[%g3], %o0		! tmp0 = p->p_forw;
-	st	%o0, [%o5]		! q->ph_link = tmp0;
-	st	%o5, [%o0 + 4]		! tmp0->p_back = q;
-	cmp	%o0, %o5		! if (tmp0 == q)
-	bne	1f
-	 EMPTY
-	mov	1, %o1			!	whichqs &= ~(1 << which);
-	sll	%o1, %o4, %o1
-	andn	%o3, %o1, %o3
-	st	%o3, [%g2 + %lo(_C_LABEL(whichqs))]
-1:
-	/*
-	 * PHASE TWO: NEW REGISTER USAGE:
+	 * REGISTER USAGE:
 	 *	%g1 = oldpsr (excluding ipl bits)
 	 *	%g2 = newpsr
-	 *	%g3 = p
-	 *	%g4 = lastproc
 	 *	%g5 = newpcb
 	 *	%g6 = %hi(_C_LABEL(cpcb))
 	 *	%g7 = %hi(_C_LABEL(curproc))
-	 *	%o0 = tmp 1
-	 *	%o1 = tmp 2
+	 *	%o0 = oldproc
+	 *	%o1 = newproc
 	 *	%o2 = tmp 3
 	 *	%o3 = vm
 	 *	%o4 = sswap
 	 *	%o5 = <free>
 	 */
 
-	/* firewalls */
-	ld	[%g3 + P_WCHAN], %o0	! if (p->p_wchan)
-	tst	%o0
-	bne	Lsw_panic_wchan		!	panic("switch wchan");
-	 EMPTY
-	ldsb	[%g3 + P_STAT], %o0	! if (p->p_stat != SRUN)
-	cmp	%o0, SRUN
-	bne	Lsw_panic_srun		!	panic("switch SRUN");
-	 EMPTY
-
 	/*
-	 * Committed to running process p.
-	 * It may be the same as the one we were running before.
+	 * Committed to running process p (in o1).
 	 */
+	mov	%o1, %g3
+
 	mov	SONPROC, %o0			! p->p_stat = SONPROC
 	stb	%o0, [%g3 + P_STAT]
 	sethi	%hi(_C_LABEL(want_resched)), %o0
 	st	%g0, [%o0 + %lo(_C_LABEL(want_resched))]	! want_resched = 0;
 	ld	[%g3 + P_ADDR], %g5		! newpcb = p->p_addr;
-	st	%g0, [%g3 + 4]			! p->p_back = NULL;
 	ld	[%g5 + PCB_PSR], %g2		! newpsr = newpcb->pcb_psr;
 	st	%g3, [%g7 + %lo(_C_LABEL(curproc))]	! curproc = p;
 
-	cmp	%g3, %g4		! p == lastproc?
-	be,a	Lsw_sameproc		! yes, go return 0
-	 wr	%g2, 0, %psr		! (after restoring ipl)
-
 	/*
-	 * Not the old process.  Save the old process, if any;
-	 * then load p.
+	 * Save the old process, if any; then load p.
 	 */
-	tst	%g4
+	tst	%o0
 	be,a	Lsw_load		! if no old process, go load
 	 wr	%g1, (IPL_CLOCK << 8) | PSR_ET, %psr
 
-	INCR(_C_LABEL(nswitchdiff))		! clobbers %o0,%o1
 	/*
 	 * save: write back all windows (including the current one).
 	 * XXX	crude; knows nwindows <= 8
@@ -4773,16 +4535,17 @@
 	 sta	%o0, [%o1] ASI_SRMMU	! setcontext(vm->vm_map.pmap->pm_ctxnum);
 #endif
 
-Lsw_sameproc:
-	/*
-	 * We are resuming the process that was running at the
-	 * call to switch().  Just set psr ipl and return.
-	 */
-!	wr	%g2, 0 %psr		! %psr = newpsr; (done earlier)
-	nop
+ENTRY(cpu_idle_enter)
+	retl
+	 nop
+
+ENTRY(cpu_idle_cycle)
 	retl
 	 nop
 
+ENTRY(cpu_idle_leave)
+	retl
+	 nop
 
 /*
  * Snapshot the current process so that stack frames are up to date.
Index: arch/sparc/sparc/vm_machdep.c
===================================================================
RCS file: /cvs/src/sys/arch/sparc/sparc/vm_machdep.c,v
retrieving revision 1.49
diff -u -r1.49 vm_machdep.c
--- arch/sparc/sparc/vm_machdep.c	20 Jun 2007 17:29:36 -0000	1.49
+++ arch/sparc/sparc/vm_machdep.c	25 Sep 2007 09:53:58 -0000
@@ -449,10 +449,9 @@
 /*
  * cpu_exit is called as the last action during exit.
  *
- * We clean up a little and then call switchexit() with the old proc
- * as an argument.  switchexit() switches to the idle context, schedules
- * the old vmspace and stack to be freed, then selects a new process to
- * run.
+ * We clean up a little and then call sched_exit() with the old proc
+ * as an argument.  sched_exit() schedules the old vmspace and stack
+ * to be freed, then selects a new process to run.
  */
 void
 cpu_exit(p)
@@ -468,8 +467,8 @@
 		free((void *)fs, M_SUBPROC);
 	}
 
-	switchexit(p);
-	/* NOTREACHED */
+	pmap_deactivate(p);
+	sched_exit(p);
 }
 
 /*
Index: arch/sparc64/conf/files.sparc64
===================================================================
RCS file: /cvs/src/sys/arch/sparc64/conf/files.sparc64,v
retrieving revision 1.89
diff -u -r1.89 files.sparc64
--- arch/sparc64/conf/files.sparc64	10 Sep 2007 21:33:16 -0000	1.89
+++ arch/sparc64/conf/files.sparc64	25 Sep 2007 09:53:59 -0000
@@ -243,7 +243,6 @@
 file	arch/sparc64/sparc64/kgdb_machdep.c	kgdb
 # sparc64/sparc64/locore.s is handled specially in the makefile,
 # because it must come first in the "ld" command line.
-file	arch/sparc64/sparc64/locore2.c
 file	arch/sparc64/sparc64/machdep.c
 file	arch/sparc64/sparc64/mem.c
 file	arch/sparc64/sparc64/mutex.S
Index: arch/sparc64/sparc64/locore.s
===================================================================
RCS file: /cvs/src/sys/arch/sparc64/sparc64/locore.s,v
retrieving revision 1.82
diff -u -r1.82 locore.s
--- arch/sparc64/sparc64/locore.s	22 Sep 2007 20:04:51 -0000	1.82
+++ arch/sparc64/sparc64/locore.s	25 Sep 2007 09:54:03 -0000
@@ -5578,350 +5578,39 @@
 	retl
 	 mov	EFAULT, %o0
 
-
-	.data
-	_ALIGN
-/*
- * Switch statistics (for later tweaking):
- *	nswitchdiff = p1 => p2 (i.e., chose different process)
- *	nswitchexit = number of calls to switchexit()
- *	_cnt.v_swtch = total calls to swtch+swtchexit
- */
-	.comm	_C_LABEL(nswitchdiff), 4
-	.comm	_C_LABEL(nswitchexit), 4
-	.text
-/*
- * REGISTER USAGE IN cpu_switch AND switchexit:
- * This is split into two phases, more or less
- * `before we locate a new proc' and `after'.
- * Some values are the same in both phases.
- * Note that the %o0-registers are not preserved across
- * the psr change when entering a new process, since this
- * usually changes the CWP field (hence heavy usage of %g's).
- *
- *	%l1 = <free>; newpcb
- *	%l2 = %hi(_whichqs); newpsr
- *	%l3 = p
- *	%l4 = lastproc
- *	%l5 = oldpsr (excluding ipl bits)
- *	%l6 = %hi(cpcb)
- *	%l7 = %hi(curproc)
- *	%o0 = tmp 1
- *	%o1 = tmp 2
- *	%o2 = tmp 3
- *	%o3 = tmp 4; whichqs; vm
- *	%o4 = tmp 4; which; sswap
- *	%o5 = tmp 5; q; <free>
- */
-
-/*
- * switchexit is called only from cpu_exit() before the current process
- * has freed its vmspace and kernel stack; we must schedule them to be
- * freed.  (curproc is already NULL.)
- *
- * We lay the process to rest by changing to the `idle' kernel stack,
- * and note that the `last loaded process' is nonexistent.
- */
-ENTRY(switchexit)
-	/*
-	 * Since we're exiting we don't need to save locals or ins, so
-	 * we won't need the next instruction.
-	 */
-!	save	%sp, -CC64FSZ, %sp
-	flushw				! We don't have anything else to run, so why not
-#ifdef DEBUG
-	save	%sp, -CC64FSZ, %sp
-	flushw
-	restore
-#endif	/* DEBUG */
-	wrpr	%g0, PSTATE_KERN, %pstate ! Make sure we're on the right globals
-	mov	%o0, %l2		! save proc arg for exit2() call XXXXX
-
-	/*
-	 * Change pcb to idle u. area, i.e., set %sp to top of stack
-	 * and %psr to PSR_S|PSR_ET, and set cpcb to point to _idle_u.
-	 * Once we have left the old stack, we can call kmem_free to
-	 * destroy it.  Call it any sooner and the register windows
-	 * go bye-bye.
-	 */
-	set	_C_LABEL(idle_u), %l1
-	sethi	%hi(CPCB), %l6
-#if 0
-	/* Get rid of the stack	*/
-	rdpr	%ver, %o0
-	wrpr	%g0, 0, %canrestore	! Fixup window state regs
-	and	%o0, 0x0f, %o0
-	wrpr	%g0, 0, %otherwin
-	wrpr	%g0, %o0, %cleanwin	! kernel don't care, but user does
-	dec	1, %o0			! What happens if we don't subtract 2?
-	wrpr	%g0, %o0, %cansave
-	flushw						! DEBUG
-#endif	/* 0 */
-
-	stx	%l1, [%l6 + %lo(CPCB)]	! cpcb = &idle_u
-	set	_C_LABEL(idle_u) + USPACE - CC64FSZ, %o0	! set new %sp
-	sub	%o0, BIAS, %sp		! Maybe this should be a save?
-	wrpr	%g0, 0, %canrestore
-	wrpr	%g0, 0, %otherwin
-	rdpr	%ver, %l7
-	and	%l7, CWP, %l7
-	wrpr	%l7, 0, %cleanwin
-	dec	1, %l7					! NWINDOWS-1-1
-	wrpr	%l7, %cansave
-	clr	%fp			! End of stack.
-#ifdef DEBUG
-	flushw						! DEBUG
-	set	_C_LABEL(idle_u), %l6
-	SET_SP_REDZONE %l6, %l5
-#endif	/* DEBUG */
-	wrpr	%g0, PSTATE_INTR, %pstate	! and then enable traps
-	call	_C_LABEL(exit2)			! exit2(p)
-	 mov	%l2, %o0
-
-#if defined(MULTIPROCESSOR) || defined(LOCKDEBUG)
-	call	_C_LABEL(sched_lock_idle)	! Acquire sched_lock
-#endif	/* defined(MULTIPROCESSOR) || defined(LOCKDEBUG) */
-	 wrpr	%g0, PIL_SCHED, %pil		! Set splsched()
-
-	/*
-	 * Now fall through to `the last switch'.  %g6 was set to
-	 * %hi(cpcb), but may have been clobbered in kmem_free,
-	 * so all the registers described below will be set here.
-	 *
-	 * Since the process has exited we can blow its context
-	 * out of the MMUs now to free up those TLB entries rather
-	 * than have more useful ones replaced.
-	 *
-	 * REGISTER USAGE AT THIS POINT:
-	 *	%l2 = %hi(_whichqs)
-	 *	%l4 = lastproc
-	 *	%l5 = oldpsr (excluding ipl bits)
-	 *	%l6 = %hi(cpcb)
-	 *	%l7 = %hi(curproc)
-	 *	%o0 = tmp 1
-	 *	%o1 = tmp 2
-	 *	%o3 = whichqs
-	 */
-
-	INCR _C_LABEL(nswitchexit)		! nswitchexit++;
-	INCR _C_LABEL(uvmexp)+V_SWTCH		! cnt.v_switch++;
-
-	mov	CTX_SECONDARY, %o0
-	sethi	%hi(_C_LABEL(whichqs)), %l2
-	sethi	%hi(CPCB), %l6
-	sethi	%hi(CURPROC), %l7
-	ldxa	[%o0] ASI_DMMU, %l1		! Don't demap the kernel
-	ldx	[%l6 + %lo(CPCB)], %l5
-	clr	%l4				! lastproc = NULL;
-	brz,pn	%l1, 1f
-	 set	DEMAP_CTX_SECONDARY, %l1	! Demap secondary context
-	stxa	%g1, [%l1] ASI_DMMU_DEMAP
-	stxa	%g1, [%l1] ASI_IMMU_DEMAP
-	membar	#Sync
-1:
-	stxa	%g0, [%o0] ASI_DMMU		! Clear out our context
-	membar	#Sync
-	/* FALLTHROUGH */
-
-/*
- * When no processes are on the runq, switch
- * idles here waiting for something to come ready.
- * The registers are set up as noted above.
- */
-	.globl	idle
-idle:
-#if defined(MULTIPROCESSOR) || defined(LOCKDEBUG)
-	call	_C_LABEL(sched_unlock_idle)	! Release sched_lock
-#endif	/* defined(MULTIPROCESSOR) || defined(LOCKDEBUG) */
-	 stx	%g0, [%l7 + %lo(CURPROC)] ! curproc = NULL;
-1:					! spin reading _whichqs until nonzero
-	wrpr	%g0, PSTATE_INTR, %pstate		! Make sure interrupts are enabled
-	wrpr	%g0, 0, %pil		! (void) spl0();
-	ld	[%l2 + %lo(_C_LABEL(whichqs))], %o3
-	brnz,pt	%o3, notidle		! Something to run
-	 nop
-#ifdef UVM_PAGE_IDLE_ZERO
-	! Check uvm.page_idle_zero
-	sethi	%hi(_C_LABEL(uvm) + UVM_PAGE_IDLE_ZERO), %o3
-	ld	[%o3 + %lo(_C_LABEL(uvm) + UVM_PAGE_IDLE_ZERO)], %o3
-	brz,pn	%o3, 1b
-	 nop
-
-	! zero some pages
-	call	_C_LABEL(uvm_pageidlezero)
-	 nop
-#endif	/* UVM_PAGE_IDLE_ZERO */
-	ba,a,pt	%xcc, 1b
-	 nop				! spitfire bug
-notidle:
-	wrpr	%g0, PIL_SCHED, %pil	! (void) splhigh();
-#if defined(MULTIPROCESSOR) || defined(LOCKDEBUG)
-	call	_C_LABEL(sched_lock_idle)	! Grab sched_lock
-	 add	%o7, (Lsw_scan-.-4), %o7	! Return to Lsw_scan directly
-#endif	/* defined(MULTIPROCESSOR) || defined(LOCKDEBUG) */
-	ba,a,pt	%xcc, Lsw_scan
-	 nop				! spitfire bug
-
-Lsw_panic_rq:
-	sethi	%hi(1f), %o0
-	call	_C_LABEL(panic)
-	 or	%lo(1f), %o0, %o0
 Lsw_panic_wchan:
-	sethi	%hi(2f), %o0
-	call	_C_LABEL(panic)
-	 or	%lo(2f), %o0, %o0
+        sethi   %hi(1f), %o0
+        call    _C_LABEL(panic)
+         or     %lo(1f), %o0, %o0
 Lsw_panic_srun:
-	sethi	%hi(3f), %o0
-	call	_C_LABEL(panic)
-	 or	%lo(3f), %o0, %o0
-	.data
-1:	.asciz	"switch rq"
-2:	.asciz	"switch wchan"
-3:	.asciz	"switch SRUN"
-idlemsg:	.asciz	"idle %x %x %x %x"
-idlemsg1:	.asciz	" %x %x %x\r\n"
-	_ALIGN
+        sethi   %hi(2f), %o0
+        call    _C_LABEL(panic)
+         or     %lo(2f), %o0, %o0
+        .data
+1:      .asciz  "switch wchan"
+2:      .asciz  "switch SRUN"
+
 	.text
 /*
- * cpu_switch() picks a process to run and runs it, saving the current
- * one away.  On the assumption that (since most workstations are
- * single user machines) the chances are quite good that the new
- * process will turn out to be the current process, we defer saving
- * it here until we have found someone to load.  If that someone
- * is the current process we avoid both store and load.
- *
- * cpu_switch() is always entered at splstatclock or splhigh.
- *
- * IT MIGHT BE WORTH SAVING BEFORE ENTERING idle TO AVOID HAVING TO
- * SAVE LATER WHEN SOMEONE ELSE IS READY ... MUST MEASURE!
+ * cpu_switchto(struct proc *old, struct proc *new)
  *
- * Apparently cpu_switch() is called with curproc as the first argument,
- * but no port seems to make use of that parameter.
+ * Save the context of "old" and switch to "new".
  */
-	.globl	_C_LABEL(time)
-ENTRY(cpu_switch)
+ENTRY(cpu_switchto)
 	save	%sp, -CC64FSZ, %sp
-	/*
-	 * REGISTER USAGE AT THIS POINT:
-	 *	%l1 = tmp 0
-	 *	%l2 = %hi(_C_LABEL(whichqs))
-	 *	%l3 = p
-	 *	%l4 = lastproc
-	 *	%l5 = cpcb
-	 *	%l6 = %hi(CPCB)
-	 *	%l7 = %hi(CURPROC)
-	 *	%o0 = tmp 1
-	 *	%o1 = tmp 2
-	 *	%o2 = tmp 3
-	 *	%o3 = tmp 4, then at Lsw_scan, whichqs
-	 *	%o4 = tmp 5, then at Lsw_scan, which
-	 *	%o5 = tmp 6, then at Lsw_scan, q
-	 */
-#ifdef DEBUG
-	set	swdebug, %o1
-	ld	[%o1], %o1
-	brz,pt	%o1, 2f
-	 set	1f, %o0
-	call	printf
-	 nop
-	.data
-1:	.asciz	"s"
-	_ALIGN
-	.globl	swdebug
-swdebug:	.word 0
-	.text
-2:
-#endif	/* DEBUG */
 	flushw				! We don't have anything else to run, so why not flush
-#ifdef DEBUG
-	save	%sp, -CC64FSZ, %sp
-	flushw
-	restore
-#endif	/* DEBUG */
 	rdpr	%pstate, %o1		! oldpstate = %pstate;
 	wrpr	%g0, PSTATE_INTR, %pstate ! make sure we're on normal globals
+
+	mov	%i0, %l4		! oldproc
+	mov	%i1, %l3		! newproc
+
 	sethi	%hi(CPCB), %l6
-	sethi	%hi(_C_LABEL(whichqs)), %l2	! set up addr regs
 	ldx	[%l6 + %lo(CPCB)], %l5
-	sethi	%hi(CURPROC), %l7
+	sethi   %hi(CURPROC), %l7
 	stx	%o7, [%l5 + PCB_PC]	! cpcb->pcb_pc = pc;
-	ldx	[%l7 + %lo(CURPROC)], %l4	! lastproc = curproc;
 	sth	%o1, [%l5 + PCB_PSTATE]	! cpcb->pcb_pstate = oldpstate;
 
-	stx	%g0, [%l7 + %lo(CURPROC)]	! curproc = NULL;
-
-Lsw_scan:
-	ld	[%l2 + %lo(_C_LABEL(whichqs))], %o3
-
-#ifndef POPC
-	.globl	_C_LABEL(__ffstab)
-	/*
-	 * Optimized inline expansion of `which = ffs(whichqs) - 1';
-	 * branches to idle if ffs(whichqs) was 0.
-	 */
-	set	_C_LABEL(__ffstab), %o2
-	andcc	%o3, 0xff, %o1		! byte 0 zero?
-	bz,a,pn	%icc, 1f		! yes, try byte 1
-	 srl	%o3, 8, %o0
-	ba,pt	%icc, 2f		! ffs = ffstab[byte0]; which = ffs - 1;
-	 ldsb	[%o2 + %o1], %o0
-1:	andcc	%o0, 0xff, %o1		! byte 1 zero?
-	bz,a,pn	%icc, 1f		! yes, try byte 2
-	 srl	%o0, 8, %o0
-	ldsb	[%o2 + %o1], %o0	! which = ffstab[byte1] + 7;
-	ba,pt	%icc, 3f
-	 add	%o0, 7, %o4
-1:	andcc	%o0, 0xff, %o1		! byte 2 zero?
-	bz,a,pn	%icc, 1f		! yes, try byte 3
-	 srl	%o0, 8, %o0
-	ldsb	[%o2 + %o1], %o0	! which = ffstab[byte2] + 15;
-	ba,pt	%icc, 3f
-	 add	%o0, 15, %o4
-1:	ldsb	[%o2 + %o0], %o0	! ffs = ffstab[byte3] + 24
-	addcc	%o0, 24, %o0		! (note that ffstab[0] == -24)
-	bz,pn	%icc, idle		! if answer was 0, go idle
-!	 XXX check no delay slot
-2:	sub	%o0, 1, %o4
-3:	/* end optimized inline expansion */
-
-#else	/* POPC */
-	/*
-	 * Optimized inline expansion of `which = ffs(whichqs) - 1';
-	 * branches to idle if ffs(whichqs) was 0.
-	 *
-	 * This version uses popc.
-	 *
-	 * XXXX spitfires and blackbirds don't implement popc.
-	 *
-	 */
-	brz,pn	%o3, idle				! Don't bother if queues are empty
-	 neg	%o3, %o1				! %o1 = -zz
-	xnor	%o3, %o1, %o2				! %o2 = zz ^ ~ -zz
-	popc	%o2, %o4				! which = popc(whichqs)
-	dec	%o4					! which = ffs(whichqs) - 1
-
-#endif	/* POPC */
-	/*
-	 * We found a nonempty run queue.  Take its first process.
-	 */
-	set	_C_LABEL(qs), %o5	! q = &qs[which];
-	sll	%o4, 3+1, %o0
-	add	%o0, %o5, %o5
-	ldx	[%o5], %l3		! p = q->ph_link;
-	cmp	%l3, %o5		! if (p == q)
-	be,pn	%icc, Lsw_panic_rq	!	panic("switch rq");
-!	 XXX check no delay slot
-	ldx	[%l3], %o0		! tmp0 = p->p_forw;
-	stx	%o0, [%o5]		! q->ph_link = tmp0;
-	stx	%o5, [%o0 + 8]	! tmp0->p_back = q;
-	cmp	%o0, %o5		! if (tmp0 == q)
-	bne	1f
-!	 XXX check no delay slot
-	mov	1, %o1			!	whichqs &= ~(1 << which);
-	sll	%o1, %o4, %o1
-	andn	%o3, %o1, %o3
-	st	%o3, [%l2 + %lo(_C_LABEL(whichqs))]
-1:
 	/*
 	 * PHASE TWO: NEW REGISTER USAGE:
 	 *	%l1 = newpcb
@@ -5950,7 +5639,6 @@
 
 	/*
 	 * Committed to running process p.
-	 * It may be the same as the one we were running before.
 	 */
 #if defined(MULTIPROCESSOR)
 	/*
@@ -5963,19 +5651,7 @@
 	sethi	%hi(CPUINFO_VA+CI_WANT_RESCHED), %o0
 	st	%g0, [%o0 + %lo(CPUINFO_VA+CI_WANT_RESCHED)]	! want_resched = 0;
 	ldx	[%l3 + P_ADDR], %l1		! newpcb = p->p_addr;
-	stx	%g0, [%l3 + 8]		! p->p_back = NULL;
-#if defined(MULTIPROCESSOR) || defined(LOCKDEBUG)
-	/*
-	 * Done mucking with the run queues, release the
-	 * scheduler lock, but keep interrupts out.
-	 */
-	call	_C_LABEL(sched_unlock_idle)
-#endif	/* defined(MULTIPROCESSOR) || defined(LOCKDEBUG) */
-	 stx	%l4, [%l7 + %lo(CURPROC)]	! restore old proc so we can save it
-
-	cmp	%l3, %l4			! p == lastproc?
-	be,pt	%xcc, Lsw_sameproc		! yes, go return 0
-	 nop
+	stx	%l4, [%l7 + %lo(CURPROC)]	! restore old proc so we can save it
 
 	/*
 	 * Not the old process.  Save the old process, if any;
@@ -5985,7 +5661,6 @@
 	brz,pn	%l4, Lsw_load		! if no old process, go load
 	 wrpr	%g0, PSTATE_KERN, %pstate
 
-	INCR _C_LABEL(nswitchdiff)	! clobbers %o0,%o1,%o2
 wb1:
 	flushw				! save all register windows except this one
 	stx	%i7, [%l5 + PCB_PC]	! Save rpc
@@ -6065,17 +5740,24 @@
 	membar	#Sync				! Maybe we should use flush here?
 	flush	%sp
 
-Lsw_sameproc:
-	/*
-	 * We are resuming the process that was running at the
-	 * call to switch().  Just set psr ipl and return.
-	 */
 !	wrpr	%g0, 0, %cleanwin	! DEBUG
 	clr	%g4		! This needs to point to the base of the data segment
 	wr	%g0, ASI_PRIMARY_NOFAULT, %asi		! Restore default ASI
 	wrpr	%g0, PSTATE_INTR, %pstate
 	ret
 	 restore
+
+ENTRY(cpu_idle_enter)
+	retl
+	 nop
+
+ENTRY(cpu_idle_cycle)
+	retl
+	 nop
+
+ENTRY(cpu_idle_leave)
+	retl
+	 nop
 
 /*
  * Snapshot the current process so that stack frames are up to date.
Index: arch/sparc64/sparc64/vm_machdep.c
===================================================================
RCS file: /cvs/src/sys/arch/sparc64/sparc64/vm_machdep.c,v
retrieving revision 1.15
diff -u -r1.15 vm_machdep.c
--- arch/sparc64/sparc64/vm_machdep.c	20 Jun 2007 17:29:36 -0000	1.15
+++ arch/sparc64/sparc64/vm_machdep.c	25 Sep 2007 09:54:03 -0000
@@ -316,8 +316,7 @@
  * run.
  */
 void
-cpu_exit(p)
-	struct proc *p;
+cpu_exit(struct proc *p)
 {
 	register struct fpstate64 *fs;
 
@@ -328,8 +327,9 @@
 		}
 		free((void *)fs, M_SUBPROC);
 	}
-	switchexit(p);
-	/* NOTREACHED */
+
+	pmap_deactivate(p);
+	sched_exit(p);
 }
 
 /*
Index: arch/vax/include/cpu.h
===================================================================
RCS file: /cvs/src/sys/arch/vax/include/cpu.h,v
retrieving revision 1.25
diff -u -r1.25 cpu.h
--- arch/vax/include/cpu.h	16 May 2007 05:19:13 -0000	1.25
+++ arch/vax/include/cpu.h	25 Sep 2007 09:54:03 -0000
@@ -129,6 +129,10 @@
  */
 #define need_proftick(p) mtpr(AST_OK,PR_ASTLVL)
 
+#define	cpu_idle_enter()	do { /* nothing */ } while (0)
+#define	cpu_idle_cycle()	do { /* nothing */ } while (0)
+#define	cpu_idle_leave()	do { /* nothing */ } while (0)
+
 /*
  * This defines the I/O device register space size in pages.
  */
Index: arch/vax/include/macros.h
===================================================================
RCS file: /cvs/src/sys/arch/vax/include/macros.h,v
retrieving revision 1.14
diff -u -r1.14 macros.h
--- arch/vax/include/macros.h	6 Nov 2006 21:31:36 -0000	1.14
+++ arch/vax/include/macros.h	25 Sep 2007 09:54:03 -0000
@@ -232,15 +232,10 @@
 	return	ret;
 }
 
-#define setrunqueue(p)	\
-	__asm__ __volatile("movl %0,r0;jsb Setrq":: "g"(p):"r0","r1","r2");
-
-#define remrunqueue(p)	\
-	__asm__ __volatile("movl %0,r0;jsb Remrq":: "g"(p):"r0","r1","r2");
-
-#define cpu_switch(p) \
-	__asm__ __volatile("movl %0,r0;movpsl -(sp);jsb Swtch" \
-	    ::"g"(p):"r0","r1","r2","r3");
+#define	cpu_switchto(o, n) \
+	__asm__ __volatile__( \
+	    "movl %0,r0; movl %1, r1; movpsl -(sp); jsb __cpu_switchto" \
+	    :: "g"(o), "g"(n) : "r0", "r1");
 
 /*
  * Interlock instructions. Used both in multiprocessor environments to
Index: arch/vax/vax/subr.s
===================================================================
RCS file: /cvs/src/sys/arch/vax/vax/subr.s,v
retrieving revision 1.26
diff -u -r1.26 subr.s
--- arch/vax/vax/subr.s	16 May 2007 05:19:15 -0000	1.26
+++ arch/vax/vax/subr.s	25 Sep 2007 09:54:04 -0000
@@ -240,114 +240,37 @@
 #endif 
 
 #
-# setrunqueue/remrunqueue fast variants.
+# void
+# cpu_switchto(struct proc *oldproc = r0, struct proc *newproc = r1);
 #
 
-JSBENTRY(Setrq)
-#ifdef DIAGNOSTIC
-	tstl	4(r0)	# Check that process actually are off the queue
-	beql	1f
-	pushab	setrq
-	calls	$1,_panic
-setrq:	.asciz	"setrunqueue"
-#endif
-1:	extzv	$2,$6,P_PRIORITY(r0),r1 # get priority
-	movaq	_qs[r1],r2		# get address of queue
-	insque	(r0),*4(r2)		# put proc last in queue
-	bbss	r1,_whichqs,1f		# set queue bit.
-1:	rsb
-
-JSBENTRY(Remrq)
-	extzv	$2,$6,P_PRIORITY(r0),r1
-#ifdef DIAGNOSTIC
-	bbs	r1,_whichqs,1f
-	pushab	remrq
-	calls	$1,_panic
-remrq:	.asciz	"remrunqueue"
-#endif
-1:	remque	(r0),r2
-	bneq	1f		# Not last process on queue
-	bbsc	r1,_whichqs,1f
-1:	clrl	4(r0)		# saftey belt
-	rsb
-
-#
-# Idle loop. Here we could do something fun, maybe, like calculating
-# pi or something.
-#
-idle:	mtpr	$0,$PR_IPL		# Enable all types of interrupts
-1:	tstl	_whichqs		# Anything ready to run?
-	beql	1b			# no, continue to loop
-	brb	Swtch			# Yes, goto switch again.
+#define CURPROC _cpu_info_store + CI_CURPROC
 
-#
-# cpu_switch, cpu_exit and the idle loop implemented in assembler 
-# for efficiency. r0 contains pointer to last process.
-#
+JSBENTRY(__cpu_switchto)
+	svpctx
 
-#define CURPROC _cpu_info_store + CI_CURPROC
+	movb	$SONPROC,P_STAT(r1)	# p->p_stat = SONPROC
+	movl	r1, CURPROC		# set new process running
 
-JSBENTRY(Swtch)
-	clrl	CURPROC			# Stop process accounting
-#bpt
-	mtpr	$0x1f,$PR_IPL		# block all interrupts
-	ffs	$0,$32,_whichqs,r3	# Search for bit set
-	beql	idle			# no bit set, go to idle loop
-
-	movaq	_qs[r3],r1		# get address of queue head
-	remque	*(r1),r2		# remove proc pointed to by queue head
-#ifdef DIAGNOSTIC
-	bvc	1f			# check if something on queue
-	pushab	noque
-	calls	$1,_panic
-noque:	.asciz	"swtch"
-#endif
-1:	bneq	2f			# more processes on queue?
-	bbsc	r3,_whichqs,2f		# no, clear bit in whichqs
-2:	clrl	4(r2)			# clear proc backpointer
-	clrl	_want_resched		# we are now changing process
-	movb	$SONPROC,P_STAT(r2)	# p->p_stat = SONPROC
-	movl	r2,CURPROC		# set new process running
-	cmpl	r0,r2			# Same process?
-	bneq	1f			# No, continue
-	rsb
-xxd:	
-1:	movl	P_ADDR(r2),r0		# Get pointer to new pcb.
+	movl	P_ADDR(r1),r0		# Get pointer to new pcb.
 	addl3	r0,$IFTRAP,pcbtrap	# Save for copy* functions.
 
-#
-# Nice routine to get physical from virtual addresses.
-#
+	# inline kvtophys
 	extzv	$9,$21,r0,r1		# extract offset
 	movl	*_Sysmap[r1],r2		# get pte
 	ashl	$9,r2,r3		# shift to get phys address.
 
 #
 # Do the actual process switch. pc + psl are already on stack, from
-# the calling routine.
+# the beginning of this routine.
 #
-	svpctx
 	mtpr	r3,$PR_PCBB
-	ldpctx
-	rei
 
-#
-# the last routine called by a process.
-#
-
-ENTRY(cpu_exit,0)
-	movl	4(ap),r6	# Process pointer in r6
-	mtpr	$0x18,$PR_IPL	# Block almost everything
-	addl3	$512,_scratch,sp # Change stack, and schedule it to be freed
-
-	pushl	r6		
-	calls	$1,_exit2
-
-	clrl	r0		# No process to switch from
-	bicl3	$0xc0000000,_scratch,r1
-	mtpr	r1,$PR_PCBB
-	brw	Swtch
+	pushl	CURPROC
+	calls	$1, _C_LABEL(pmap_activate)
 
+	ldpctx
+	rei
 
 #
 # copy/fetch/store routines. 
Index: arch/vax/vax/vm_machdep.c
===================================================================
RCS file: /cvs/src/sys/arch/vax/vax/vm_machdep.c,v
retrieving revision 1.34
diff -u -r1.34 vm_machdep.c
--- arch/vax/vax/vm_machdep.c	20 Jun 2007 17:29:36 -0000	1.34
+++ arch/vax/vax/vm_machdep.c	25 Sep 2007 09:54:04 -0000
@@ -58,6 +58,16 @@
 
 #include <sys/syscallargs.h>
 
+void
+cpu_exit(struct proc *p)
+{
+	int s;
+	s = splhigh();	/* splclock(); */
+
+	pmap_deactivate(p);
+	sched_exit(p);
+}
+
 /*
  * Finish a fork operation, with process p2 nearly set up.
  * Copy and update the pcb and trap frame, making the child ready to run.
@@ -109,13 +119,6 @@
 	tf = (struct trapframe *)((u_int)p2->p_addr + USPACE) - 1;
 	p2->p_addr->u_pcb.framep = tf;
 	bcopy(p1->p_addr->u_pcb.framep, tf, sizeof(*tf));
-
-	/*
-	 * Activate address space for the new process.	The PTEs have
-	 * already been allocated by way of pmap_create().
-	 * This writes the page table registers to the PCB.
-	 */
-	pmap_activate(p2);
 
 	/* Mark guard page invalid in kernel stack */
 	*kvtopte((u_int)p2->p_addr + REDZONEADDR) &= ~PG_V;
Index: conf/files
===================================================================
RCS file: /cvs/src/sys/conf/files,v
retrieving revision 1.410
diff -u -r1.410 files
--- conf/files	12 Sep 2007 12:59:55 -0000	1.410
+++ conf/files	25 Sep 2007 09:54:05 -0000
@@ -645,6 +645,7 @@
 file kern/kern_proc.c
 file kern/kern_prot.c
 file kern/kern_resource.c
+file kern/kern_sched.c
 file kern/kern_sensors.c		!small_kernel
 file kern/kern_sig.c
 file kern/kern_subr.c
